## kimageannotator 0.3.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(kImageAnnotator LANGUAGES CXX VERSION 0.3.2)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

option(BUILD_TESTS "Build Unit Tests" OFF)
option(BUILD_EXAMPLE "Build Example Application" ON)

include(GNUInstallDirs)

if (WIN32)
	set(KIMAGEANNOTATOR_LANG_INSTALL_DIR "translations")
elseif (APPLE)
	set(KIMAGEANNOTATOR_LANG_INSTALL_DIR "../Resources")
elseif (UNIX)
	set(KIMAGEANNOTATOR_LANG_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/kImageAnnotator/translations")
	string(REGEX REPLACE "//" "/" KIMAGEANNOTATOR_LANG_INSTALL_DIR "${KIMAGEANNOTATOR_LANG_INSTALL_DIR}")
endif ()

set(QT_MIN_VERSION "5.9.4")
find_package(Qt5 ${QT_MIN_VERSION} REQUIRED Widgets Svg)

if (UNIX AND NOT APPLE)
	find_package(X11 REQUIRED)
endif ()

include(FeatureSummary)

set(KCOLORPICKER_MIN_VERSION "0.1.4")
find_package(kColorPicker ${KCOLORPICKER_MIN_VERSION} REQUIRED)

set(BASEPATH "${CMAKE_CURRENT_SOURCE_DIR}")
include_directories("${BASEPATH}")

add_subdirectory(src)
add_subdirectory(translations)

if (BUILD_EXAMPLE)
	add_subdirectory(example)
endif (BUILD_EXAMPLE)

if (BUILD_TESTS)
	find_package(Qt5 ${QT_MIN_VERSION} REQUIRED Test)
	enable_testing()
	add_subdirectory(tests)
endif (BUILD_TESTS)

include(CMakePackageConfigHelpers)

add_library(kImageAnnotator
			${KIMAGEANNOTATOR_SRCS}
			${CMAKE_CURRENT_SOURCE_DIR}/include/kImageAnnotator/KImageAnnotator.h
			${CMAKE_CURRENT_SOURCE_DIR}/resources/kImageAnnotator_resources.qrc
			)

add_library(kImageAnnotator::kImageAnnotator ALIAS kImageAnnotator)

target_include_directories(kImageAnnotator
						   PUBLIC
						   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
						   $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>
						   $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
						   )

target_link_libraries(kImageAnnotator PUBLIC Qt5::Widgets Qt5::Svg kColorPicker::kColorPicker)

if (UNIX AND NOT APPLE)
	target_link_libraries(kImageAnnotator PUBLIC X11)
endif ()

target_compile_definitions(kImageAnnotator PRIVATE KIMAGEANNOTATOR_LIB)

set_target_properties(kImageAnnotator
					  PROPERTIES
					  ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib
					  LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib
					  RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/bin
					  SOVERSION ${PROJECT_VERSION}
					  )

install(TARGETS kImageAnnotator
		EXPORT kImageAnnotator-targets
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
		)

install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/kImageAnnotator
		DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
		)

configure_package_config_file(
		${CMAKE_CURRENT_SOURCE_DIR}/cmake/kImageAnnotatorConfig.cmake.in
		${CMAKE_CURRENT_BINARY_DIR}/cmake/kImageAnnotatorConfig.cmake
		INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/kImageAnnotator
)

write_basic_package_version_file(
		${CMAKE_CURRENT_BINARY_DIR}/cmake/kImageAnnotatorConfig-version.cmake
		VERSION ${PROJECT_VERSION}
		COMPATIBILITY AnyNewerVersion
)

install(FILES
		${CMAKE_CURRENT_BINARY_DIR}/cmake/kImageAnnotatorConfig.cmake
		${CMAKE_CURRENT_BINARY_DIR}/cmake/kImageAnnotatorConfig-version.cmake
		DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/kImageAnnotator
		)

export(
		EXPORT kImageAnnotator-targets
		FILE ${CMAKE_CURRENT_BINARY_DIR}/cmake/kImageAnnotator-targets.cmake
		NAMESPACE kImageAnnotator::
)

install(
		EXPORT kImageAnnotator-targets
		FILE kImageAnnotator-targets.cmake
		NAMESPACE kImageAnnotator::
		DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/kImageAnnotator
)

# uninstall target
if(NOT TARGET uninstall)
    configure_file(
        "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
        "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
        IMMEDIATE @ONLY)

    add_custom_target(uninstall COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif()

=== debian/changelog ===
kimageannotator (0.3.2-1) unstable; urgency=medium

  * New upstream release. 

 -- Boyuan Yang <byang@debian.org>  Tue, 04 Aug 2020 22:10:07 -0400

kimageannotator (0.3.1-5) unstable; urgency=high

  * Let libkimageannotator-common to properly Breaks+Replaces
    older version of libkimageannotator0. (Closes: #964464)

 -- Boyuan Yang <byang@debian.org>  Tue, 07 Jul 2020 17:03:47 -0400

kimageannotator (0.3.1-4) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Mon, 06 Jul 2020 10:41:40 -0400

kimageannotator (0.3.1-4~exp1) experimental; urgency=medium

  * Split translation files into separeate libkimageannotator-common
    package.

 -- Boyuan Yang <byang@debian.org>  Sun, 28 Jun 2020 16:13:20 -0400

kimageannotator (0.3.1-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sun, 28 Jun 2020 16:07:53 -0400

kimageannotator (0.3.0.20200624-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Wed, 24 Jun 2020 13:53:10 -0400

kimageannotator (0.2.1-1) unstable; urgency=medium

  * Initial release. (Closes: #956322)

 -- Boyuan Yang <byang@debian.org>  Thu, 09 Apr 2020 16:41:00 -0400

=== debian/control ===
Source: kimageannotator
Section: libs
Priority: optional
Maintainer: Boyuan Yang <byang@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake (>= 3.5),
 qtbase5-dev,
 libkcolorpicker-dev (>= 0.1.4~),
 qttools5-dev-tools,
 qttools5-dev,
 libqt5svg5-dev,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://github.com/ksnip/kImageAnnotator
Vcs-Git: https://salsa.debian.org/debian/kimageannotator.git
Vcs-Browser: https://salsa.debian.org/debian/kimageannotator

Package: libkimageannotator-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libkcolorpicker-dev,
 libkimageannotator0 (= ${binary:Version}),
 ${misc:Depends},
Description: Image Annotating Library (dev)
 The kImageAnnotator library provides tools to annotate
 images. This library is used by the ksnip project.
 .
 This package provides the development files.

Package: libkimageannotator0
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libkimageannotator-common (= ${source:Version}),
Description: Image Annotating Library (lib)
 The kImageAnnotator library provides tools to annotate
 images. This library is used by the ksnip project.
 .
 This package provides the shared library.

Package: libkimageannotator-common
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Breaks: libkimageannotator0 (<< 0.3.1-3),
Replaces: libkimageannotator0 (<< 0.3.1-3),
Description: Image Annotating Library (common data files)
 The kImageAnnotator library provides tools to annotate
 images. This library is used by the ksnip project.
 .
 This package provides the architecture-independent files used by
 the library, including the translation files.

## kimageannotator 0.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(kImageAnnotator LANGUAGES CXX VERSION 0.3.2)
+project(kImageAnnotator LANGUAGES CXX VERSION 0.4.0)
 
 set(CMAKE_CXX_STANDARD 11)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
@@ -67,10 +67,10 @@
 						   $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
 						   )
 
-target_link_libraries(kImageAnnotator PUBLIC Qt5::Widgets Qt5::Svg kColorPicker::kColorPicker)
+target_link_libraries(kImageAnnotator PUBLIC Qt5::Widgets Qt5::Svg PRIVATE kColorPicker::kColorPicker)
 
 if (UNIX AND NOT APPLE)
-	target_link_libraries(kImageAnnotator PUBLIC X11)
+	target_link_libraries(kImageAnnotator PRIVATE X11)
 endif ()
 
 target_compile_definitions(kImageAnnotator PRIVATE KIMAGEANNOTATOR_LIB)

=== src/CMakeLists.txt ===
set(KIMAGEANNOTATOR_SRCS
	${CMAKE_CURRENT_SOURCE_DIR}/gui/KImageAnnotator.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/CoreView.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/AnnotationWidget.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/AnnotationView.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/AnnotationViewZoomer.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/WidgetConfigurator.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/AnnotationSettings.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/tabs/AnnotationTabContent.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/tabs/AnnotationTabWidget.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/tabs/AnnotationTabContextMenu.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/tabs/AnnotationTabCloser.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/cropper/CropWidget.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/cropper/CropView.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/cropper/CropSelectionHandler.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/cropper/CropSelectionRestrictor.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/cropper/CropHandles.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/cropper/CropSelectionMoveHelper.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/scaler/ScaleDialog.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/scaler/ScaleWidget.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gui/scaler/ScaleSizeHandler.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/ZoomValueProvider.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/AnnotationArea.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/AnnotationItemFactory.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/AnnotationPropertiesFactory.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/AbstractSettingsProvider.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/imageEffects/ImageEffectFactory.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/imageEffects/NoImageEffect.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/imageEffects/DropShadowImageEffect.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/imageEffects/BorderImageEffect.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/imageEffects/GrayscaleImageEffect.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/properties/AnnotationProperties.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/properties/AnnotationPathProperties.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/properties/AnnotationTextProperties.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/properties/AnnotationObfuscateProperties.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/properties/AnnotationStickerProperties.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/AnnotationItemModifier.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/AnnotationItemResizer.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/AnnotationMultiItemResizer.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/AnnotationItemSelector.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/AnnotationItemMover.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/AnnotationItemArranger.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/AnnotationItemEditor.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/resizeHandles/AbstractItemResizeHandles.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/resizeHandles/AbstractRectResizeHandles.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/resizeHandles/LineResizeHandles.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/resizeHandles/RectResizeHandles.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/resizeHandles/PathResizeHandles.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/resizeHandles/PointerRectResizeHandles.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/resizeHandles/ResizeHandle.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/modifiers/resizeHandles/ResizeHandlesFactory.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AbstractAnnotationItem.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AbstractAnnotationLine.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AbstractAnnotationObfuscate.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AbstractAnnotationRect.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AbstractAnnotationPointerRect.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AbstractAnnotationPath.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationLine.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationArrow.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationDoubleArrow.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationRect.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationEllipse.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationNumber.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationNumberPointer.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationNumberArrow.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationPen.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationPixelate.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationText.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationTextPointer.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationTextArrow.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationBlur.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationImage.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationSticker.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/BaseAnnotationNumber.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/text/AnnotationTextHandler.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/text/KeyInputHelper.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/text/TextCursor.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/text/CapsLockStatusChecker.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/helper/NumberRectHelper.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/helper/AnnotationShapeCreator.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/AddCommand.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/DeleteCommand.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/MoveCommand.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/ResizeCommand.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/ArrangeCommand.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/CropCommand.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/ScaleCommand.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/PasteCommand.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/ChangePropertiesCommand.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/misc/ShadowEffect.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/misc/ImageBlurrer.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/misc/AnnotationItemClipboard.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/misc/AnnotationContextMenu.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/annotations/misc/NumberManager.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/backend/Config.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/provider/DevicePixelRatioScaler.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/CursorHelper.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/KeyHelper.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/MathHelper.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/ItemHelper.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/ShapeHelper.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/ConfigNameHelper.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/IconLoader.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/PathHelper.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/filter/IgnoreShortcutsFilter.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/common/filter/KeyEventListener.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/ToolPicker.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/ColorPicker.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/NumberPicker.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/FillModePicker.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/CustomSpinBox.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/CustomToolButton.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/CustomToolButtonAction.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/StickerPicker.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/menuButtons/GridMenu.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/menuButtons/GridMenuButton.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/menuButtons/GridMenuToolButton.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/menuButtons/ListMenuToolButton.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/menuButtons/ListMenu.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/menuButtons/ListMenuItem.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/menuButtons/ListItemGroup.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/ImageEffectPicker.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/widgets/ZoomIndicator.cpp
	)

set(KIMAGEANNOTATOR_SRCS ${KIMAGEANNOTATOR_SRCS} PARENT_SCOPE)

=== tests/CMakeLists.txt ===
set(UNITTEST_SRC
	annotations/core/AnnotationAreaTest.cpp
	annotations/core/AnnotationItemFactoryTest.cpp
	annotations/core/AnnotationPropertiesFactoryTest.cpp
	annotations/modifiers/AnnotationItemResizerTest.cpp
	annotations/modifiers/AnnotationMultiItemResizerTest.cpp
	annotations/modifiers/AnnotationItemSelectorTest.cpp
	annotations/modifiers/AnnotationItemModifierTest.cpp
	annotations/modifiers/AnnotationItemArrangerTest.cpp
	annotations/modifiers/AnnotationItemMoverTest.cpp
	annotations/modifiers/resizeHandles/LineResizeHandlesTest.cpp
	annotations/modifiers/resizeHandles/RectResizeHandlesTest.cpp
	annotations/modifiers/resizeHandles/PointerRectResizeHandlesTest.cpp
	annotations/undo/AddCommandTest.cpp
	annotations/undo/DeleteCommandTest.cpp
	annotations/undo/MoveCommandTest.cpp
	annotations/undo/ResizeCommandTest.cpp
	annotations/undo/ArrangeCommandTest.cpp
	annotations/undo/CropCommandTest.cpp
	annotations/undo/ScaleCommandTest.cpp
	annotations/undo/PasteCommandTest.cpp
	annotations/items/helper/KeyInputHelperTest.cpp
	annotations/items/helper/TextCursorTest.cpp
	annotations/misc/AnnotationItemClipboardTest.cpp
	annotations/misc/NumberManagerTest.cpp
	backend/ConfigTest.cpp
	common/helper/KeyHelperTest.cpp
	common/helper/MathHelperTest.cpp
	common/helper/ItemHelperTest.cpp
	common/helper/ShapeHelperTest.cpp
	common/helper/PathHelperTest.cpp
	gui/cropper/CropSelectionRestrictorTest.cpp
	gui/cropper/CropSelectionMoveHelperTest.cpp
	gui/cropper/CropSelectionHandlerTest.cpp
	gui/cropper/CropHandlesTest.cpp
	gui/scaler/ScaleSizeHandlerTest.cpp
	gui/annotator/tabs/AnnotationTabCloserTest.cpp
	gui/annotator/tabs/AnnotationTabContextMenuTest.cpp
	widgets/ToolPickerTest.cpp
	widgets/ColorPickerTest.cpp
	widgets/NumberPickerTest.cpp
	widgets/FillModePickerTest.cpp
	widgets/ImageEffectPickerTest.cpp
	widgets/CustomSpinBoxTest.cpp
	widgets/StickerPickerTest.cpp
	)

set(TESTUTILS_SRC
    mocks/MockZoomValueProvider.cpp
	mocks/MockSettingsProvider.cpp
	mocks/MockDevicePixelRatioScaler.cpp
	mocks/MockDefaultParameters.h
	)

add_library(KIMAGEANNOTATOR_STATIC STATIC ${KIMAGEANNOTATOR_SRCS})

target_link_libraries(KIMAGEANNOTATOR_STATIC Qt5::Widgets Qt5::Svg kImageAnnotator)

foreach (UnitTest ${UNITTEST_SRC})
	get_filename_component(UnitTestName ${UnitTest} NAME_WE)
	add_executable(${UnitTestName} ${UnitTest} ${TESTUTILS_SRC})
	target_link_libraries(${UnitTestName} KIMAGEANNOTATOR_STATIC Qt5::Test)
	add_test(${UnitTestName} ${UnitTestName})
endforeach (UnitTest)

=== translations/CMakeLists.txt ===
find_package(Qt5LinguistTools)

set(KIMAGEANNOTATOR_LANG_TS
	kImageAnnotator_cs.ts
	kImageAnnotator_da.ts
	kImageAnnotator_de.ts
	kImageAnnotator_el.ts
	kImageAnnotator_es.ts
	kImageAnnotator_eu.ts
	kImageAnnotator_fr.ts
	kImageAnnotator_fr_CA.ts
	kImageAnnotator_gl.ts
	kImageAnnotator_hu.ts
	kImageAnnotator_id.ts
	kImageAnnotator_it.ts
	kImageAnnotator_ja.ts
	kImageAnnotator_nl.ts
	kImageAnnotator_no.ts
	kImageAnnotator_pl.ts
	kImageAnnotator_pt.ts
	kImageAnnotator_ru.ts
	kImageAnnotator_sv.ts
	kImageAnnotator_tr.ts
	kImageAnnotator_uk.ts
    kImageAnnotator_zh_CN.ts)

if (DEFINED UPDATE_TS_FILES)
	qt5_create_translation(KIMAGEANNOTATOR_LANG_QM ${CMAKE_SOURCE_DIR}/translations ${KIMAGEANNOTATOR_SRCS} ${KIMAGEANNOTATOR_LANG_TS} OPTIONS "-no-obsolete")
else ()
	qt5_add_translation(KIMAGEANNOTATOR_LANG_QM ${KIMAGEANNOTATOR_LANG_TS})
endif ()

add_custom_target(translations ALL DEPENDS ${KIMAGEANNOTATOR_LANG_QM})

install(FILES ${KIMAGEANNOTATOR_LANG_QM} DESTINATION ${KIMAGEANNOTATOR_LANG_INSTALL_DIR})

=== debian/changelog ===
kimageannotator (0.4.0-2) unstable; urgency=high

  * debian/patches: Add patch 0001 from upstream to properly
    handle library SONAME. (Closes: #977649)
  * debian/control: Bump libkcolorpicker version requirement
    to 0.1.5 to properly handle SONAME issue.

 -- Boyuan Yang <byang@debian.org>  Sat, 26 Dec 2020 22:29:08 -0500

kimageannotator (0.4.0-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Thu, 17 Dec 2020 14:36:06 -0500

kimageannotator (0.3.2-2) unstable; urgency=medium

  * debian/: Fix some lintian warnings.
  * debian/patches/0001: Add patch from upstream trunk to make
    the zh_CN translation actually working.

 -- Boyuan Yang <byang@debian.org>  Mon, 12 Oct 2020 13:19:39 -0400

=== debian/control ===
--- 
+++ 
@@ -6,11 +6,11 @@
  debhelper-compat (= 13),
  cmake (>= 3.5),
  qtbase5-dev,
- libkcolorpicker-dev (>= 0.1.4~),
+ libkcolorpicker-dev (>= 0.1.5~),
  qttools5-dev-tools,
  qttools5-dev,
  libqt5svg5-dev,
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://github.com/ksnip/kImageAnnotator
 Vcs-Git: https://salsa.debian.org/debian/kimageannotator.git

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%kimageannotator-$1.tar.gz%" \
 https://github.com/ksnip/kimageannotator/releases \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## kimageannotator 0.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,12 @@
 cmake_minimum_required(VERSION 3.5)
-project(kImageAnnotator LANGUAGES CXX VERSION 0.4.0)
+project(kImageAnnotator LANGUAGES CXX VERSION 0.5.0)
 
 set(CMAKE_CXX_STANDARD 11)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
+
+set(CMAKE_CXX_VISIBILITY_PRESET hidden)
+set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
 
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTORCC ON)
@@ -31,11 +34,10 @@
 
 include(FeatureSummary)
 
-set(KCOLORPICKER_MIN_VERSION "0.1.4")
+set(KCOLORPICKER_MIN_VERSION "0.1.6")
 find_package(kColorPicker ${KCOLORPICKER_MIN_VERSION} REQUIRED)
 
-set(BASEPATH "${CMAKE_CURRENT_SOURCE_DIR}")
-include_directories("${BASEPATH}")
+include_directories(${CMAKE_CURRENT_SOURCE_DIR})
 
 add_subdirectory(src)
 add_subdirectory(translations)
@@ -70,17 +72,23 @@
 target_link_libraries(kImageAnnotator PUBLIC Qt5::Widgets Qt5::Svg PRIVATE kColorPicker::kColorPicker)
 
 if (UNIX AND NOT APPLE)
-	target_link_libraries(kImageAnnotator PRIVATE X11)
+	if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.14.0)
+		target_link_libraries(kImageAnnotator PRIVATE X11::X11)
+	else()
+		target_link_libraries(kImageAnnotator PRIVATE X11)
+	endif()
 endif ()
 
 target_compile_definitions(kImageAnnotator PRIVATE KIMAGEANNOTATOR_LIB)
+target_compile_definitions(kImageAnnotator PRIVATE KIMAGEANNOTATOR_LANG_INSTALL_DIR="${KIMAGEANNOTATOR_LANG_INSTALL_DIR}")
 
 set_target_properties(kImageAnnotator
 					  PROPERTIES
 					  ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib
 					  LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib
 					  RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/bin
-					  SOVERSION ${PROJECT_VERSION}
+					  VERSION ${PROJECT_VERSION}
+					  SOVERSION 0
 					  )
 
 install(TARGETS kImageAnnotator

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -13,12 +13,14 @@
 	annotations/modifiers/resizeHandles/PointerRectResizeHandlesTest.cpp
 	annotations/undo/AddCommandTest.cpp
 	annotations/undo/DeleteCommandTest.cpp
+	annotations/undo/ModifyCanvasCommandTest.cpp
 	annotations/undo/MoveCommandTest.cpp
 	annotations/undo/ResizeCommandTest.cpp
 	annotations/undo/ArrangeCommandTest.cpp
 	annotations/undo/CropCommandTest.cpp
 	annotations/undo/ScaleCommandTest.cpp
 	annotations/undo/PasteCommandTest.cpp
+	annotations/undo/RotateCommandTest.cpp
 	annotations/items/helper/KeyInputHelperTest.cpp
 	annotations/items/helper/TextCursorTest.cpp
 	annotations/misc/AnnotationItemClipboardTest.cpp
@@ -30,19 +32,22 @@
 	common/helper/ShapeHelperTest.cpp
 	common/helper/PathHelperTest.cpp
 	gui/cropper/CropSelectionRestrictorTest.cpp
-	gui/cropper/CropSelectionMoveHelperTest.cpp
-	gui/cropper/CropSelectionHandlerTest.cpp
-	gui/cropper/CropHandlesTest.cpp
+	gui/canvasModifier/ModifyCanvasSelectionRestrictorTest.cpp
+	gui/selection/SelectionMoveHelperTest.cpp
+	gui/selection/SelectionHandlerTest.cpp
+	gui/selection/SelectionHandlesTest.cpp
 	gui/scaler/ScaleSizeHandlerTest.cpp
 	gui/annotator/tabs/AnnotationTabCloserTest.cpp
 	gui/annotator/tabs/AnnotationTabContextMenuTest.cpp
-	widgets/ToolPickerTest.cpp
-	widgets/ColorPickerTest.cpp
-	widgets/NumberPickerTest.cpp
-	widgets/FillModePickerTest.cpp
-	widgets/ImageEffectPickerTest.cpp
 	widgets/CustomSpinBoxTest.cpp
-	widgets/StickerPickerTest.cpp
+		widgets/misc/AttachedSeparatorTest.cpp
+	widgets/settingsPicker/ToolPickerTest.cpp
+	widgets/settingsPicker/ColorPickerTest.cpp
+	widgets/settingsPicker/NumberPickerTest.cpp
+	widgets/settingsPicker/FillModePickerTest.cpp
+	widgets/settingsPicker/ImageEffectPickerTest.cpp
+	widgets/settingsPicker/StickerPickerTest.cpp
+	widgets/settingsPicker/ZoomPickerTest.cpp
 	)
 
 set(TESTUTILS_SRC
@@ -50,11 +55,20 @@
 	mocks/MockSettingsProvider.cpp
 	mocks/MockDevicePixelRatioScaler.cpp
 	mocks/MockDefaultParameters.h
+	mocks/MockSelectionRestrictor.cpp
 	)
 
 add_library(KIMAGEANNOTATOR_STATIC STATIC ${KIMAGEANNOTATOR_SRCS})
 
-target_link_libraries(KIMAGEANNOTATOR_STATIC Qt5::Widgets Qt5::Svg kImageAnnotator)
+target_link_libraries(KIMAGEANNOTATOR_STATIC Qt5::Widgets Qt5::Svg kImageAnnotator kColorPicker::kColorPicker)
+
+if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.14.0)
+	target_link_libraries(KIMAGEANNOTATOR_STATIC X11::X11)
+else()
+	target_link_libraries(KIMAGEANNOTATOR_STATIC X11)
+endif()
+
+target_compile_definitions(KIMAGEANNOTATOR_STATIC PRIVATE KIMAGEANNOTATOR_LANG_INSTALL_DIR="${KIMAGEANNOTATOR_LANG_INSTALL_DIR}")
 
 foreach (UnitTest ${UNITTEST_SRC})
 	get_filename_component(UnitTestName ${UnitTest} NAME_WE)

=== translations/CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,7 @@
 	kImageAnnotator_fr.ts
 	kImageAnnotator_fr_CA.ts
 	kImageAnnotator_gl.ts
+	kImageAnnotator_hr.ts
 	kImageAnnotator_hu.ts
 	kImageAnnotator_id.ts
 	kImageAnnotator_it.ts
@@ -18,6 +19,7 @@
 	kImageAnnotator_no.ts
 	kImageAnnotator_pl.ts
 	kImageAnnotator_pt.ts
+	kImageAnnotator_pt_BR.ts
 	kImageAnnotator_ru.ts
 	kImageAnnotator_sv.ts
 	kImageAnnotator_tr.ts

=== debian/changelog ===
kimageannotator (0.5-0.1~mx21+1) mx; urgency=medium

  * New upstream release.
  * debian/control: Bump version requirement of kcolorpicker.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 29 May 2021 14:28:17 -0700

kimageannotator (0.4.2-1~exp1) experimental; urgency=medium

  * New upstream release.
  * debian/patches: Drop patches, merged upstream.
  * debian/control: Bump version requirement of kcolorpicker.

 -- Boyuan Yang <byang@debian.org>  Sat, 03 Apr 2021 10:32:38 -0400

=== debian/control ===
Source: kimageannotator
Section: libs
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Boyuan Yang <byang@debian.org>
Build-Depends: cmake (>= 3.5),
               debhelper-compat (= 12),
               libkcolorpicker-dev (>= 0.1.6),
               libqt5svg5-dev,
               qtbase5-dev,
               qttools5-dev,
               qttools5-dev-tools
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://github.com/ksnip/kImageAnnotator
Vcs-Git: https://salsa.debian.org/debian/kimageannotator.git
Vcs-Browser: https://salsa.debian.org/debian/kimageannotator

Package: libkimageannotator-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libkcolorpicker-dev,
         libkimageannotator0 (= ${binary:Version}),
         ${misc:Depends}
Description: Image Annotating Library (dev)
 The kImageAnnotator library provides tools to annotate
 images. This library is used by the ksnip project.
 .
 This package provides the development files.

Package: libkimageannotator0
Architecture: any
Multi-Arch: same
Depends: libkimageannotator-common (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Image Annotating Library (lib)
 The kImageAnnotator library provides tools to annotate
 images. This library is used by the ksnip project.
 .
 This package provides the shared library.

Package: libkimageannotator-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: libkimageannotator0 (<< 0.3.1-3)
Replaces: libkimageannotator0 (<< 0.3.1-3)
Description: Image Annotating Library (common data files)
 The kImageAnnotator library provides tools to annotate
 images. This library is used by the ksnip project.
 .
 This package provides the architecture-independent files used by
 the library, including the translation files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND =

export QT_SELECT := 5


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DBUILD_SHARED_LIBS=ON

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## kimageannotator 0.5.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(kImageAnnotator LANGUAGES CXX VERSION 0.5.0)
+project(kImageAnnotator LANGUAGES CXX VERSION 0.5.1)
 
 set(CMAKE_CXX_STANDARD 11)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)

## kimageannotator 0.5.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(kImageAnnotator LANGUAGES CXX VERSION 0.5.1)
+project(kImageAnnotator LANGUAGES CXX VERSION 0.5.2)
 
 set(CMAKE_CXX_STANDARD 11)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -3,19 +3,33 @@
 	${CMAKE_CURRENT_SOURCE_DIR}/gui/CoreView.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/AnnotationWidget.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/AnnotationView.cpp
-	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/AnnotationViewZoomer.cpp
-	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/WidgetConfigurator.cpp
-	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/AnnotationSettings.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/gui/scrollAndZoomView/ScrollAndZoomView.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/gui/scrollAndZoomView/ViewZoomer.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/settings/ItemSettingsWidgetConfigurator.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/settings/AnnotationSettingsAdapter.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/settings/AnnotationItemSettings.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/settings/AnnotationImageSettings.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/settings/AnnotationGeneralSettings.cpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/settings/AnnotationToolSelection.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/docks/AnnotationDockWidget.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/docks/AnnotationDockWidgetDragHandle.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/docks/AbstractAnnotationDockWidgetContent.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/tabs/AnnotationTabContent.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/tabs/AnnotationTabWidget.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/tabs/AnnotationTabContextMenu.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/gui/annotator/tabs/AnnotationTabCloser.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/gui/canvasModifier/ModifyCanvasView.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/gui/canvasModifier/ModifyCanvasWidget.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/gui/canvasModifier/ModifyCanvasSelectionRestrictor.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/gui/cropper/CropWidget.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/gui/cropper/CropView.cpp
-	${CMAKE_CURRENT_SOURCE_DIR}/gui/cropper/CropSelectionHandler.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/gui/cropper/CropSelectionRestrictor.cpp
-	${CMAKE_CURRENT_SOURCE_DIR}/gui/cropper/CropHandles.cpp
-	${CMAKE_CURRENT_SOURCE_DIR}/gui/cropper/CropSelectionMoveHelper.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/gui/selection/SelectionHandler.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/gui/selection/SelectionMoveHelper.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/gui/selection/SelectionHandles.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/gui/selection/BaseSelectionView.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/gui/rotator/RotateDialog.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/gui/rotator/RotateWidget.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/gui/scaler/ScaleDialog.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/gui/scaler/ScaleWidget.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/gui/scaler/ScaleSizeHandler.cpp
@@ -24,11 +38,12 @@
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/AnnotationItemFactory.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/AnnotationPropertiesFactory.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/AbstractSettingsProvider.cpp
-	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/imageEffects/ImageEffectFactory.cpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/imageEffects/ImageEffectFactory.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/imageEffects/NoImageEffect.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/imageEffects/DropShadowImageEffect.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/imageEffects/BorderImageEffect.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/imageEffects/GrayscaleImageEffect.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/annotations/core/imageEffects/InvertColorImageEffect.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/properties/AnnotationProperties.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/properties/AnnotationPathProperties.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/properties/AnnotationTextProperties.cpp
@@ -56,6 +71,9 @@
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AbstractAnnotationPointerRect.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AbstractAnnotationPath.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationLine.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationMarkerEllipse.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationMarkerPen.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationMarkerRect.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationArrow.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationDoubleArrow.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationRect.cpp
@@ -71,6 +89,7 @@
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationBlur.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationImage.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationSticker.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/AnnotationDuplicate.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/BaseAnnotationNumber.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/text/AnnotationTextHandler.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/text/KeyInputHelper.cpp
@@ -80,20 +99,25 @@
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/items/helper/AnnotationShapeCreator.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/AddCommand.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/DeleteCommand.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/FlipCommand.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/MoveCommand.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/ResizeCommand.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/ArrangeCommand.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/CropCommand.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/ScaleCommand.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/RotateCommand.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/PasteCommand.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/ChangePropertiesCommand.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/annotations/undo/ModifyCanvasCommand.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/misc/ShadowEffect.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/misc/ImageBlurrer.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/misc/AnnotationItemClipboard.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/misc/AnnotationContextMenu.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/annotations/misc/NumberManager.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/annotations/misc/CanvasPainter.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/backend/Config.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/common/provider/DevicePixelRatioScaler.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/common/provider/ScaledSizeProvider.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/CursorHelper.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/KeyHelper.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/MathHelper.cpp
@@ -105,13 +129,21 @@
 	${CMAKE_CURRENT_SOURCE_DIR}/common/filter/IgnoreShortcutsFilter.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/common/filter/KeyEventListener.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/widgets/ToolPicker.cpp
-	${CMAKE_CURRENT_SOURCE_DIR}/widgets/ColorPicker.cpp
-	${CMAKE_CURRENT_SOURCE_DIR}/widgets/NumberPicker.cpp
-	${CMAKE_CURRENT_SOURCE_DIR}/widgets/FillModePicker.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/widgets/CustomFontComboBox.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/widgets/CustomSpinBox.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/widgets/CustomToolButton.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/widgets/CustomToolButtonAction.cpp
-	${CMAKE_CURRENT_SOURCE_DIR}/widgets/StickerPicker.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/widgets/ToggleButton.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/widgets/ColorDialogButton.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/widgets/settingsPicker/ColorPicker.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/widgets/settingsPicker/NumberPicker.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/widgets/settingsPicker/BoolPicker.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/widgets/settingsPicker/FillModePicker.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/widgets/settingsPicker/FontPicker.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/widgets/settingsPicker/SettingsPickerWidget.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/widgets/settingsPicker/StickerPicker.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/widgets/settingsPicker/ImageEffectPicker.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/widgets/settingsPicker/ZoomPicker.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/widgets/menuButtons/GridMenu.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/widgets/menuButtons/GridMenuButton.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/widgets/menuButtons/GridMenuToolButton.cpp
@@ -119,8 +151,9 @@
 	${CMAKE_CURRENT_SOURCE_DIR}/widgets/menuButtons/ListMenu.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/widgets/menuButtons/ListMenuItem.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/widgets/menuButtons/ListItemGroup.cpp
-	${CMAKE_CURRENT_SOURCE_DIR}/widgets/ImageEffectPicker.cpp
-	${CMAKE_CURRENT_SOURCE_DIR}/widgets/ZoomIndicator.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/widgets/misc/AbstractExpandingWidget.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/widgets/misc/FlowLayout.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/widgets/misc/AttachedSeparator.cpp
 	)
 
 set(KIMAGEANNOTATOR_SRCS ${KIMAGEANNOTATOR_SRCS} PARENT_SCOPE)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -40,7 +40,7 @@
 	gui/annotator/tabs/AnnotationTabCloserTest.cpp
 	gui/annotator/tabs/AnnotationTabContextMenuTest.cpp
 	widgets/CustomSpinBoxTest.cpp
-		widgets/misc/AttachedSeparatorTest.cpp
+	widgets/misc/AttachedSeparatorTest.cpp
 	widgets/settingsPicker/ToolPickerTest.cpp
 	widgets/settingsPicker/ColorPickerTest.cpp
 	widgets/settingsPicker/NumberPickerTest.cpp

=== debian/changelog ===
kimageannotator (0.5.2-1~mx21+1) mx; urgency=medium

  * Initial packaging of upstream backports release for MX-21.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Mon, 18 Oct 2021 15:05:32 -0400

kimageannotator (0.5.2-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boyuan Yang <byang@debian.org>  Thu, 30 Sep 2021 21:22:37 -0400

kimageannotator (0.5.2-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Mon, 13 Sep 2021 22:51:16 -0400

kimageannotator (0.5.1-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boyuan Yang <byang@debian.org>  Tue, 24 Aug 2021 23:15:44 -0400

kimageannotator (0.5.1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Tue, 17 Aug 2021 14:25:15 -0400

kimageannotator (0.5.1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * debian/control: Bump version requirement of kcolorpicker.

 -- Boyuan Yang <byang@debian.org>  Mon, 16 Aug 2021 23:44:06 -0400

=== debian/control ===
Source: kimageannotator
Section: libs
Priority: optional
Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
XSBC-Original-Maintainer: Boyuan Yang <byang@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake (>= 3.5),
 qtbase5-dev,
 libkcolorpicker-dev (>= 0.1.6~),
 qttools5-dev-tools,
 qttools5-dev,
 libqt5svg5-dev,
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://github.com/ksnip/kImageAnnotator
Vcs-Git: https://salsa.debian.org/debian/kimageannotator.git
Vcs-Browser: https://salsa.debian.org/debian/kimageannotator

Package: libkimageannotator-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libkcolorpicker-dev,
 libkimageannotator0 (= ${binary:Version}),
 ${misc:Depends},
Description: Image Annotating Library (dev)
 The kImageAnnotator library provides tools to annotate
 images. This library is used by the ksnip project.
 .
 This package provides the development files.

Package: libkimageannotator0
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libkimageannotator-common (= ${source:Version}),
Description: Image Annotating Library (lib)
 The kImageAnnotator library provides tools to annotate
 images. This library is used by the ksnip project.
 .
 This package provides the shared library.

Package: libkimageannotator-common
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Breaks: libkimageannotator0 (<< 0.3.1-3),
Replaces: libkimageannotator0 (<< 0.3.1-3),
Description: Image Annotating Library (common data files)
 The kImageAnnotator library provides tools to annotate
 images. This library is used by the ksnip project.
 .
 This package provides the architecture-independent files used by
 the library, including the translation files.

## kimageannotator 0.5.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(kImageAnnotator LANGUAGES CXX VERSION 0.5.2)
+project(kImageAnnotator LANGUAGES CXX VERSION 0.5.3)
 
 set(CMAKE_CXX_STANDARD 11)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -128,6 +128,7 @@
 	${CMAKE_CURRENT_SOURCE_DIR}/common/helper/PathHelper.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/common/filter/IgnoreShortcutsFilter.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/common/filter/KeyEventListener.cpp
+	${CMAKE_CURRENT_SOURCE_DIR}/common/platform/PlatformChecker.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/widgets/ToolPicker.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/widgets/CustomFontComboBox.cpp
 	${CMAKE_CURRENT_SOURCE_DIR}/widgets/CustomSpinBox.cpp

=== translations/CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,9 @@
 	kImageAnnotator_pl.ts
 	kImageAnnotator_pt.ts
 	kImageAnnotator_pt_BR.ts
+	kImageAnnotator_ro.ts
 	kImageAnnotator_ru.ts
+	kImageAnnotator_si.ts
 	kImageAnnotator_sv.ts
 	kImageAnnotator_tr.ts
 	kImageAnnotator_uk.ts

=== debian/changelog ===
kimageannotator (0.5.3-1) unstable; urgency=medium

  * New upstream release 0.5.3.
  * debian/shlibs: Tighten version requirement.

 -- Boyuan Yang <byang@debian.org>  Tue, 23 Nov 2021 16:38:55 -0500

kimageannotator (0.5.2-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on cmake.

  [ Boyuan Yang ]
  * debian/control: Bump Standards-Version to 4.6.0.
  * debian/libkimageannotator0.shlibs: Tighten version to latest.
  * debian/watch: Fix uscan grammar.

 -- Boyuan Yang <byang@debian.org>  Wed, 10 Nov 2021 09:09:38 -0500

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,16 @@
 Source: kimageannotator
 Section: libs
 Priority: optional
-Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
-XSBC-Original-Maintainer: Boyuan Yang <byang@debian.org>
+Maintainer: Boyuan Yang <byang@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
- cmake (>= 3.5),
+ cmake,
  qtbase5-dev,
  libkcolorpicker-dev (>= 0.1.6~),
  qttools5-dev-tools,
  qttools5-dev,
  libqt5svg5-dev,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://github.com/ksnip/kImageAnnotator
 Vcs-Git: https://salsa.debian.org/debian/kimageannotator.git

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
 https://github.com/ksnip/kimageannotator/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
